package org.apache.commons.lang3.concurrent;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.concurrent.atomic.AtomicReference;
import org.apache.commons.lang3.concurrent.ConcurrentException;
import org.apache.commons.lang3.concurrent.ConcurrentInitializer;

public abstract class AtomicSafeInitializer<T> implements ConcurrentInitializer<T> {
  private final AtomicReference<org.apache.commons.lang3.concurrent.AtomicSafeInitializer<T>> factory = new AtomicReference<>();
  
  private final AtomicReference<T> reference = new AtomicReference<>();
  
  public final T get() throws ConcurrentException {
    T result;
    while ((result = this.reference.get()) == null) {
      if (this.factory.compareAndSet(null, this))
        this.reference.set(initialize()); 
    } 
    return result;
  }
  
  protected abstract T initialize() throws ConcurrentException;
}
